
#prototype dfp-x.R1.gnls

library(MASS)

"pulest" <-
function(x, y, data=sys.parent(), baseline=list(nb=~x, rk=cubic(x)), puloc, start, type = c("dblexp", "user"), params=list(infrate="common", decrate="mixed", amplitude="mixed"), pulse.usr=list(shape, parlist, devlist), weights = NULL, correlation = NULL, control=pul.control(IDF=1))
{

  .env <- environment()

"GenModel0" <- function(lp, form, parL) {
  # form : input basic pulse (two-sided) formula, not a function.
  # lp   : potential locations.
  # parL : parameters list as described in top calling function
  OLD.options <- options()
  on.exit(options(OLD.options))
  options(width=500,length=500)
  "Split" <- function(x,y) {
    ## where x : Character string to be split, y : character flag used to split x
    "CS" <- function(x, str) {
      ## CS, 'C'haracter 'S'plit, where x : char to be screened in 'str'
      FLAG <- 1
      jk <- character(0)
      while ( FLAG ) {
        w1 <- regexpr(x, str)
        Lw1 <- attr(w1, "match.length")
        if ( w1 != -1 ) {
          jk <- c(jk,substring(str, 1, w1))
          str <- substring(str, w1+Lw1, nchar(str))
          FLAG <- 1
          } else {
            jk <- c(jk, str)
            FLAG <- 0
            } }
      jk
      }
    # END CS(x,str)
    str1 <- x
    assign("CS", CS, env=.env)
    for ( i in 1:length(y) ) {
      j <- length(str1)
      tmp2 <- character(0)
      for ( k in 1:j) {
        tmp <- CS(y[i], str1[k])
        tmp2 <- c(tmp2,tmp)
        }
      str1 <- tmp2
      }
    str1
    } # END Split(x,y)
  assign("Split", Split, env=.env)
  pchar <- as.character(form)[3]
  seg <- Split(pchar, unlist(parL["p"], use.names=F) )
  modelfun <- character(0)
  for ( i in 1:length(lp) ) {
    OLDseg <- seg
    findP <-regexpr( unlist(parL["p"],use.names=F), seg)
    for ( j in 1:length(findP) ) {
      if ( findP[j] != -1 )
        seg[j] <- paste( substring(seg[j],1,findP[j]-attr(findP,"match.length")[j]),lp[i],sep="" )
      }
    MID.i.seg <- paste(seg, collapse="")
    modelfun <- paste(modelfun ,"+",MID.i.seg,sep="")
    # get rid of 1st symbol and wrap up formula
    if ( i == length(lp)) {
      modelfun <- substring(modelfun,2, nchar(modelfun))
      modelfun <- formula(paste( as.character(form)[2],modelfun, sep="~"))
      }
    seg <- OLDseg
    }
  return(modelfun)
}




"defx" <- function(y, x, params){
  if(params$decrate=="mixed" & params$amplitude=="mixed"){
     "def.1.derA" <- function(time,...) {
     		exp(a+A)*exp((time-P)*exp(l)*(time <= P))*(time <= P)+exp(a+A)*exp(-(time-P)*exp(r + R)*(time > P))*(time > P)
     }
     "def.1.dera" <- def.1.derA
     "def.1.derR" <- function(time,...) {
    		tmp <-  - (time - P) * exp(r+R)*(time>P)
    		exp(a+A)*exp(tmp)*tmp*(time>P)
     }
     "def.1.derr" <- function(time,...) {
    		tmp <-  - (time - P) * exp(r+R)*(time>P)
	      exp(a+A)*exp(tmp)*tmp*(time>P)
     }
    "def.1.derl" <- function(time,...) {
    		tmp <-  (time - P) * exp(l)*(time <= P)
	      exp(a+A)*exp(tmp)*tmp*(time <= P)
    }
##??? missing  assign("def.1.dera", def.1.dera, env=.env)  seems no use?
#    assign("def.1.derA", def.1.derA, env=.env)
#    assign("def.1.derR", def.1.derR, env=.env)
#    assign("def.1.derr", def.1.derr, env=.env)
#    assign("def.1.derl", def.1.derl, env=.env)
    pform <- as.formula(paste( y, "~ exp(a+A)*exp((", x, "-P)*exp(l)*(", x, "<= P))*(",
                            x, "<= P)+exp(a+A)*exp(-(", x,"-P)*exp(r + R)*(",x,"> P))*(",x,"> P)", sep=""))
    return(list(form = pform, parlist = list(random=c("A","R"), common=c("l","r", "a"), p="P"),
       der = list(def.1.derl, def.1.derr, def.1.dera, def.1.derA, def.1.derR)))
  }
  else if(params$decrate=="mixed")
  {    
    "def.1.dera" <- function(time,...) {
 	   exp(a)*exp((time-P)*exp(l)*(time <= P))*(time <= P)+exp(a)*exp(-(time-P)*exp(r + R)*(time > P))*(time > P)
    }
    "def.1.derR" <- function(time,...) {
  	  tmp <-  - (time - P) * exp(r+R)*(time>P)
    	  exp(a)*exp(tmp)*tmp*(time>P)
    }
   "def.1.derr" <- function(time,...) {
    	  tmp <-  - (time - P) * exp(r+R)*(time>P)
	  exp(a)*exp(tmp)*tmp*(time>P)
    }
   "def.1.derl" <- function(time,...) {
    	  tmp <-  (time - P) * exp(l)*(time <= P)
        exp(a)*exp(tmp)*tmp*(time <= P)
   }
#   assign("def.1.dera", def.1.dera, env=.env)
#   assign("def.1.derR", def.1.derR, env=.env)
#   assign("def.1.derr", def.1.derr, env=.env)
#   assign("def.1.derl", def.1.derl, env=.env)
   pform <- as.formula(paste( y, "~ exp(a)*exp((", x, "-P)*exp(l)*(", x, "<= P))*(",
                            x, "<= P)+exp(a)*exp(-(", x,"-P)*exp(r + R)*(",x,"> P))*(",x,"> P)", sep=""))
   if(params$amplitude=="common")
    return(list(form = pform, parlist = list(random=c("R"), common=c("l","r", "a"), p="P"),
       der = list(def.1.derl, def.1.derr, def.1.dera, def.1.derR)))
   else if(params$amplitude=="fixed")
    return(list(form = pform, parlist = list(random=c("R"), fixed=c("a"), common=c("l","r"), p="P"),
       der = list(def.1.derl, def.1.derr, def.1.derR, def.1.dera)))
   else 
    return(list(form = pform, parlist = list(random=c("a", "R"), common=c("l","r"), p="P"),
       der = list(def.1.derl, def.1.derr, def.1.dera, def.1.derR)))

  }
  else if(params$amplitude=="mixed")
  {
     "def.1.derA" <- function(time,...) {
     		exp(a+A)*exp((time-P)*exp(l)*(time <= P))*(time <= P)+exp(a+A)*exp(-(time-P)*exp(r)*(time > P))*(time > P)
     }
     "def.1.dera" <- def.1.derA
     "def.1.derr" <- function(time,...) {
    		tmp <-  - (time - P) * exp(r)*(time>P)
    		exp(a+A)*exp(tmp)*tmp*(time>P)
     }
    "def.1.derl" <- function(time,...) {
    		tmp <-  (time - P) * exp(l)*(time <= P)
	      exp(a+A)*exp(tmp)*tmp*(time <= P)
    }
#    assign("def.1.derA", def.1.derA, env=.env)
#    assign("def.1.dera", def.1.derR, env=.env)
#    assign("def.1.derr", def.1.derr, env=.env)
#    assign("def.1.derl", def.1.derl, env=.env)
    pform <- as.formula(paste( y, "~ exp(a+A)*exp((", x, "-P)*exp(l)*(", x, "<= P))*(",
                            x, "<= P)+exp(a+A)*exp(-(", x,"-P)*exp(r)*(",x,"> P))*(",x,"> P)", sep=""))
    if(params$decrate=="common")
     return(list(form = pform, parlist = list(random=c("A"), common=c("l",,"r", "a"), p="P"),
       der = list(def.1.derl, def.1.derr, def.1.dera, def.1.derA)))
    else
     return(list(form = pform, parlist = list(random=c("A"), fixed=c("r"), common=c("l", "a"), p="P"),
       der = list( def.1.derl, def.1.dera, def.1.derA, def.1.derr)))
  }
  else
  {
     "def.1.dera" <- function(time,...) {
    		exp(a)*exp((time-P)*exp(l)*(time <= P))*(time <= P)+exp(a)*exp(-(time-P)*exp(r)*(time > P))*(time > P)
    	}
     "def.1.derr" <- function(time,...) {
  		tmp <-  - (time - P) * exp(r)*(time>P)
 		   exp(a)*exp(tmp)*tmp*(time>P)
     }
     "def.1.derl" <- function(time,...) {
    		tmp <-  (time - P) * exp(l)*(time <= P)
    		   exp(a)*exp(tmp)*tmp*(time <= P)
     }
#     assign("def.1.dera", def.1.dera, env=.env)
#     assign("def.1.derr", def.1.derr, env=.env)
#     assign("def.1.derl", def.1.derl, env=.env)
     pform <- as.formula(paste( y, "~ exp(a)*exp((", x, "-P)*exp(l)*(", x, "<= P))*(", x, "<= P)+exp(a)*exp(-(", x,"-P)*exp(r)*(",x,"> P))*(",x,"> P)", sep=""))
     if(params$decrate=="common" & params$amplitude=="common")
       return(list(form = pform, parlist = list(common=c("l", "r", "a"), p="P"), der = list(def.1.derl, def.1.derr, def.1.dera)))
     else if(params$decrate=="common" & params$amplitude=="fixed")  
       return(list(form = pform, parlist = list(common=c("l", "r"), fixed=c("a"), p="P"), der = list(def.1.derl, def.1.derr, def.1.dera)))
     else if(params$decrate=="common" & params$amplitude=="random")  
       return(list(form = pform, parlist = list(common=c("l", "r"), random=c("a"), p="P"), der = list(def.1.derl, def.1.derr, def.1.dera)))
     else if(params$decrate=="fixed" & params$amplitude=="common")
       return(list(form = pform, parlist = list(common=c("l", "a"), fixed=c("r"), p="P"), der = list(def.1.derl, def.1.dera, def.1.derr)))
     else if(params$decrate=="fixed" & params$amplitude=="fixed")
       return(list(form = pform, parlist = list(common=c("l"), fixed=c("r", "a"), p="P"), der = list(def.1.derl, def.1.derr, def.1.dera))) 
     else if(params$decrate=="fixed" & params$amplitude=="random")
       return(list(form = pform, parlist = list(common=c("l"), fixed=c("r"), random=c("a"), p="P"), der = list(def.1.derl, def.1.dera, def.1.derr))) 
   }
}  



posterior.ranef.info <-  function(nlmefit, ssrfit, baseline, LP, x, devlist, pList, Sigma2, level = 0.05)
{
# a special function calculating posterior statisitcs for nonlinear mixed effects
# hence it applies to special form of covariance matrix, not used arbitrarily
# Refer to the paper "That BLUP is a good thing" and Yuedong's mixed SSANOVA paper
	pList.old <- pList
        pList <- list(fixed=pList$common, random=as.list(c(pList$random, pList$fixed)), p=pList$p)
        Z <- numeric(0)    
        for(k in 1:length(pList$fixed)) {
                assign(pList$fixed[k], nlmefit$NextFixed[k], env=.env)
        }
        if(length(pList$random) != 0)
	{ 
           Block <- vector("list", length(unlist(pList$random)))
           for(i in 1:length(unlist(pList$random))) {
                Block[[i]] <- numeric(0)
            }

           ABP <- cbind(matrix(c(nlmefit$ranEst, nlmefit$NextFixed[-c(1:length(pList$fixed))]), nrow = length(nlmefit$P)), nlmefit$P)
           dimnames(ABP)[[2]] <- unlist(c(pList$random, pList$p), use.names = F)

### Initial values for fixed effectc matrix X
           for(i in 1:length(LP)) {
                for(j in 1:length(pList$random)) {
                        assign(pList$random[[j]], ABP[i, j], env=.env)
                }
                assign(pList$p, ABP[i, pList$p], env=.env)

                for(j in 1:length(unlist(pList$random))) {
                        Block[[j]] <- cbind(Block[[j]], apply(as.matrix(x), 1,
                                devlist[[j+length(pList$fixed)]]))
                }
                if(i == length(LP)) {
                        Z <- numeric(0)
                        for(k in 1:length(Block))
                                Z <- cbind(Z, Block[[k]])
                }
           }
        } 
        X <- matrix(rep(0, length(x)*length(pList$fixed)), nrow=length(x))    
        for(i in 1:length(LP)) {
                 assign(pList$p, LP[i], env=.env)
####The following loop is for derivatives of fixed effects
                XX <- NULL
                for(j in 1:length(pList$fixed)) {
                        XX <- cbind(XX, apply(as.matrix(x), 1,
                                devlist[[j]]))
                }

                X <- X+XX
         }
        
        if(length(pList.old$random)==0) 
		{ X <- cbind(X, Z)
                  Z <- numeric(0)
            }
	 else
	      { X <- cbind(X, Z[,-c(1:(length(pList.old$random)*length(LP)))])
       	        Z <- Z[,c(1:(length(pList.old$random)*length(LP)))]
        	 } 
  # calculate the posterior; script implies at least one random effects
        ransd <- nlmefit$ranSdDev
        diaG <- G <- numeric(0)
        W.inv  <- diag(rep(1,length(x)))
        if(length(ransd) != 0 )
        {
           for(i in 1:length(ransd)) {
                diaG <- c(diaG, rep(ransd[i]^2, length(LP)))
           }
         
#        Dq <- diag(diaG)/(nlmefit$info["SdDev"])^2
#        Zhat <- rbind(Z, chol(ginv(Dq)))    # symbols as used in NLME papers

         G <- diag(sqrt(diaG)/nlmefit$info["SdDev"])
         W.inv <- Z%*%G%*%t(Z)+ W.inv
        }
	if(is.null(baseline)) 
	  {
		Tmat <- X
		B <- W.inv
	  }
	  else
	  { 
	  Tmat <- cbind(ssrfit$ssrObj$s, X)
          nlambda <- 10^ssrfit$ssrObj$rkpk.obj$nlaht
          B <- ssrfit$ssrObj$q[[1]]/nlambda + W.inv
	  }

        qr.result <- qr(Tmat)
        qrq <- qr.Q(qr.result, complete = T)
        qrq2 <- qrq[, (ncol(Tmat) + 1):length(x)]
        qrq1 <- qrq[, 1:ncol(Tmat)]
        qrr <- qr.R(qr.result)
        qrr.inv <- solve(qrr)
        
        H <- qrq2 %*% ginv(t(qrq2)%*%B%*%qrq2) %*% t(qrq2)
        
        ginvB <- ginv(B)
        fixVar <-  Sigma2*qrr.inv%*%ginv(t(qrq1)%*%ginvB%*%qrq1)%*%t(qrr.inv)
        if(is.null(baseline)) Varmat <- fixVar
        else
        Varmat <- fixVar[-c(1:ncol(ssrfit$ssrObj$s)),-c(1:ncol(ssrfit$ssrObj$s))]
        obj <- NULL

        if(length(pList.old$random) != 0)
        {
          I2 <- diag(rep(1, length(diaG)))
          ranVar <-  Sigma2 * G %*% (I2-t(Z)%*%H%*%Z%*%G)
          fixranCov <- - fixVar %*% t(Tmat) %*% ginvB %*% Z %*% G
          if(is.null(baseline)) Varmat <- rbind(cbind(fixVar, fixranCov), cbind(t(fixranCov), ranVar))
          else
          Varmat <- rbind(cbind(fixVar[,-c(1:ncol(ssrfit$ssrObj$s))], fixranCov)[-c(1:ncol(ssrfit$ssrObj$s)),], cbind(t(fixranCov[-c(1:ncol(ssrfit$ssrObj$s)),]), ranVar))        
        
          tbl <- cbind(nlmefit$ranEst, diag(ranVar))
          assign("level", level, env=.env)
          obj <- t(apply(tbl, 1, FUN = function(x, Level = level)
          {
                tstat <- x[1]/sqrt(x[2])
                pvalue <- 2 * (1 - pnorm(tstat))
                ind <- ifelse(pvalue < Level, 1, 0)
                ubd <- x[1] + qnorm(1 - level/2) * sqrt(x[2])
                lbd <- x[1] - qnorm(1 - level/2) * sqrt(x[2])
                c(tstat, pvalue, lbd, ubd, ind)
          }
          ))
          dimnames(obj)[[2]] <- c("t-value", "p-value", "lower-bdd", "upper-bdd",
                "significant")
        }        
        return(list(obj=obj, Var= Varmat))
} #


"GNLScallx" <- function(tmp, Fixed, P, pulse, parList, gnls.control, corr, weight )
{
# tmp is a data.frame with the same name of data
# pulse : input basic pulse formula, not a function. e.g. conc ~ exp(time)
# Fixed   : initial used to fit NLME
# parList : list of (par, fixed, pos) of parameters.
  assign("tmp", tmp, env=.env)
  assign("P", P, env=.env)	
  n <- length(P)
  Fixfor <- as.formula(paste(paste(parList$common, collapse = "+"), "~1",sep = ""))
  if(is.null(parList$fixed))
  { 
	  modfor <- GenModel0(P, pulse, parList)
	  fit <- gnls(modfor, data = tmp, params=list(Fixfor), start=c(Fixed), control=gnls.control, correlation=corr, weights=weight) 
  }
  else
  {
	ranpar <- as.list(unlist(parList$fixed, use.names = F))
	RanList <- lapply(ranpar, FUN = function(x, k)
                    {
                      Rd <- paste(x, 1:k, "+", sep = "", collapse = "")
                }
                    , n)	# wrapup fixed, random and model formula used in NLME
 	temp <- paste(RanList, collapse = "")
	Ranfor <- as.formula(paste(substring(temp, 1, nchar(temp)-1), "~1",sep = ""))
  	modfor <- GenModel(P, pulse, list(common=parList$common, random=as.list(parList$fixed), p=parList$p))
  	fit <- gnls(modfor, data = tmp, params=list(Fixfor, Ranfor), start=c(Fixed), control=gnls.control, correlation=corr, weights=weight) 
  }
  fixed.est <- fit$coef
  invisible(list(fit = as.vector(fit$fitted), P = P,
                 info = c(LogLik = logLik(fit), AICV = AIC(fit), BICV = BIC(fit),
                   SdDev = fit$sigma), NextFixed=fixed.est, gnlsObj = fit))
#}
###########deal with problem of breakdown of gnls###########
#  else
#  return(NA)
#############################################################
}


"SSRcall" <- function(y, s, form, Updata, rk, op = "v", corr, weight, limnla)
{
  # Updata should be scaled beforehand
  assign("rk", rk, env=.env)
#  rk <- eval(rk, envir=Updata)
  fit.dsidr <- dsidr(y=y, s=s, q=rk, vmu=op, limnla=limnla)
#  fit <- ssr(as.formula(form), data = Updata, rk = rk, method = op,  correlation =corr, weight=weight, limnla=limnla)
##########################
Call <- quote(ssr(formula = as.formula(form),  data = Updata, rk = list(rk), spar = op, correlation =corr, weight=weight, limnla=limnla))

fit <- list(call = Call, expand.call = Call, data = Updata, 
        y = y, weight = weight, fit = as.vector(fit.dsidr$fit), 
        s = s, q = list(rk), lambda = 10^fit.dsidr$nlaht/dim(data)[1], residuals = as.vector(fit.dsidr$resi), 
        sigma = sqrt(fit.dsidr$varht), family = "gaussian", coef = list(c = fit.dsidr$c, 
            d = fit.dsidr$d), df = fit.dsidr$df, rkpk.obj = fit.dsidr, 
        scale = FALSE, cor.est = NULL, var.est = NULL, 
        control = ssr.control())
   
    class(fit) <- "ssr"
    fit$call[[1]] <- as.name("ssr")
   
    fit$lme.obj <- NULL
################################

  invisible(list(fit = fit$fit, gcvS = fit$rkpk.obj$score, nlaht = fit$rkpk.obj$nlaht,
                 score = fit$rkpk.obj$vmu, ssrObj = fit))
  }


"NLMEcallx" <- function(tmp, Fixed, P, pulse, parList, nlme.control, corr, weight )
{
# tmp is a data.frame with the same name of data
# pulse : input basic pulse formula, not a function. e.g. conc ~ exp(time)
# Fixed   : initial used to fit NLME
# parList : list of (par, fixed, pos) of parameters.
  assign("tmp", tmp, env=.env)
  assign("P", P, env=.env)	# prepare for construction of random effects
  n <- length(P)
  ranpar <- as.list(parList$random)
  RanList <- lapply(ranpar, FUN = function(x, k)
                    {
                      Rd <- paste(x, 1:k, "+", sep = "", collapse = "")
                      pdIdent(formula(paste(substring(Rd, 1, nchar(Rd) - 1), "~", 1,collapse = "")))
                      }
                    , n)
  fixpar <- as.list(parList$fixed)
  FixList <- lapply(fixpar, FUN = function(x, k)
                    {
                      Rd <- paste(x, 1:k, "+", sep = "", collapse = "")
                    }
                    , n)	
  temp <- paste( paste(parList$common, collapse = "+"), paste(FixList, collapse = ""), sep="+")
  Fixfor <- as.formula(paste(substring(temp, 1, nchar(temp)-1), "~1",sep = ""))
  if(length(ranpar) > 1)
  Ranfor <- pdBlocked(RanList)
  else Ranfor <- RanList[[1]]	
# external GenModel()
  modfor <- GenModel(P, pulse, list(common=parList$common, random=list(parList$random, parList$fixed), p=parList$p))
###########################################################
  group <- rep(1, dim(tmp)[1])
  fit <- nlme(modfor, data = data.frame(tmp, group), fixed = Fixfor, random = list(group=Ranfor), control = nlme.control,
              start = Fixed, method = "REML", correlation = corr, weights = weight)
  ranEst <- fit$coef$random$group[1,]
  ranSd <- exp(as.vector(coef(fit$modelStruct, T))) * fit$sigma
  invisible(list(fit = as.vector(fit$fitted[, 2]), ranEst = ranEst, P = P,
                 info = c(LogLik = logLik(fit), AICV = AIC(fit), BICV = BIC(fit),
                   SdDev = fit$sigma), ranSdDev = ranSd,
                 NextFixed = fit$coef$fixed, nlmeObj = fit))
#}
###########deal with problem of breakdown of nlme###########
#  else
#  return(NA)
#############################################################
}


"GenModel" <- function(lp, form, parL) {
  # form : input basic pulse (two-sided) formula, not a function.
  # lp   : potential locations.
  # parL : parameters list as described in top calling function
  OLD.options <- options()
  on.exit(options(OLD.options))
  options(width=500,length=500)
  "Split" <- function(x,y) {
    ## where x : Character string to be split, y : character flag used to split x
    "CS" <- function(x, str) {
      ## CS, 'C'haracter 'S'plit, where x : char to be screened in 'str'
      FLAG <- 1
      jk <- character(0)
      while ( FLAG ) {
        w1 <- regexpr(x, str)
        Lw1 <- attr(w1, "match.length")
        if ( w1 != -1 ) {
          jk <- c(jk,substring(str, 1, w1))
          str <- substring(str, w1+Lw1, nchar(str))
          FLAG <- 1
          } else {
            jk <- c(jk, str)
            FLAG <- 0
            } }
      jk
      }
    # END CS(x,str)
    str1 <- x
    assign("CS", CS, env=.env)
    for ( i in 1:length(y) ) {
      j <- length(str1)
      tmp2 <- character(0)
      for ( k in 1:j) {
        tmp <- CS(y[i], str1[k])
        tmp2 <- c(tmp2,tmp)
        }
      str1 <- tmp2
      }
    str1
    } # END Split(x,y)
  assign("Split", Split, env=.env)
  pchar <- as.character(form)[3]
  seg <- Split(pchar, unlist(parL[c("random","p")], use.names=F) )
  # above split wrt all parameters except 'fixed'
  modelfun <- character(0)
  for ( i in 1:length(lp) ) {
    OLDseg <- seg
    findP <-regexpr( unlist(parL["p"],use.names=F), seg)
    for ( j in 1:length(findP) ) {
      if ( findP[j] != -1 )
        seg[j] <- paste( substring(seg[j],1,findP[j]-attr(findP,"match.length")[j]),lp[i],sep="" )
      }
    MID.i.seg <- paste(seg, collapse="")
    seg <- Split(MID.i.seg, unlist(parL$random, use.names=F))
    jk <- paste(seg,i, sep="")
    jk[length(seg)] <- ifelse(i<10,
                              substring( jk[length(seg)],1, nchar(jk[length(seg)])-1),
                              substring( jk[length(seg)],1, nchar(jk[length(seg)])-2))
    # self-adding
    jk <- paste(jk,collapse="")
    modelfun <- paste(modelfun ,"+",jk ,sep="")
    # get rid of 1st symbol and wrap up formula
    if ( i == length(lp)) {
      modelfun <- substring(modelfun,2, nchar(modelfun))
      modelfun <- formula(paste( as.character(form)[2],modelfun, sep="~"))
      }
    seg <- OLDseg
    }
  return(modelfun)
}
#debug(NLMEcallx)
#debug(GNLScallx)
#debug(posterior.ranef.info)
  
  xcall <- match.call()
  assign("xcall", xcall, env=.env)
  ###????get names of x and y
  res <- deparse(xcall$y)
  ind <- deparse(xcall$x)
  data.orig <- data
  x <- eval(xcall$x, data.orig)
  y <- eval(xcall$y, data.orig) 
      
  data <- data.frame(x, y)
  dimnames(data)[[2]] <- c(ind, res)
  
  if(is.element("baseline", names(xcall)))
    if(!is.element("list", all.names(xcall$baseline)))
         {baseline <- eval(xcall$baseline, sys.parent())
          if(!is.list(baseline))
             {if(is.numeric(baseline))
               {if(length(baseline) > 0)
                 {if(baseline==0) 
                   baseline <- 0
                  
                 else 
                 stop("wrong format of baseline input")
                 }
               else
                 stop("wrong format of baseline input")
               }
             else
               stop("wrong format of baseline input")
           }
          else {varName <- unique(all.vars(baseline$nb))
                if(varName==res) stop("response appears on the rhs")}

         }
         if(is.null(xcall$baseline)) {
            baseline <- quote(list(nb=~x, rk=cubic(x)))
            varName <- "x"}
      else if(xcall$baseline==0) baseline <- NULL
      else if(is.element("list", all.names(xcall$baseline))) 
          {baseline <- xcall$baseline
           varName <- unique(all.vars(baseline$rk))
  
  if(varName==res) stop("response appears on the rhs")}
  if(missing(type))
    stop("type must be sepecified, eihter \"dblexp\" or \"user\"")
  
  type <- match.arg(type)
  tmp <- tmp0 <- data
  nlme <- TRUE
  if(type == "dblexp")
    {
     if(missing(params)) stop("params must be specified when type is dblexp")
     if(params$infrate!="common") stop("infussion rate can only be of type common")
     if(!is.element(params$decrate, c("common", "mixed", "fixed"))) stop("decay rate can only be one of the following types: common, fixed, and mixed")
     if(!is.element(params$amplitude, c("common", "mixed", "fixed", "random"))) stop("amplitude can only be one of the following types: common, fixed, mixed, and random") 
     parList <- defx(res, ind, params)$parlist
     devList <- defx(res, ind, params)$der
     pulseForm <- defx(res, ind, params)$form
     if(params$decrate != "mixed" & params$amplitude != "mixed" & params$amplitude != "random") nlme <- FALSE
    } 
 else
    {
      if(missing(pulse.usr$shape) | missing(pulse.usr$parlist) | missing(pulse.usr$devlist))
        stop("shape, parlist, and devlist should be provided when type is \"user\"")
      if(!((class(pulse.usr$shape) == "formula") & (length(pulse.usr$shape) == 3)))
        stop("shape should be two-sided formula")
      if(!(is.list(pulse.usr$devlist) & is.list(pulse.usr$parlist)))
        stop("parlist and devlist should be lists.")
      # figure out fixed effects parameters
      ##xx <-  parameter.names(pulse.usr$shape, data)
      ##yy <-  unlist(pulse.usr$params, use.names=F)
      ##pulse.usr$params$fixed <- xx[ match(xx,yy) == "NA" ]
      parList <- pulse.usr$parlist
      devList <- pulse.usr$devlist
      pulseForm <- pulse.usr$shape
      }
  ctr <- pul.control(IDF=1)
  if(!missing(control)) {
    if(!all(is.element(names(control), c("nlme", "ssr", "gnls", "pul"))))
       stop("control must be a list with names nlme, ssr, gnls or pul")
    if(!is.null(control$nlme))
      ctr$nlme[names(control$nlme)] <- control$nlme
    if(!is.null(control$ssr))
      ctr$ssr[names(control$ssr)] <- control$ssr
    if(!is.null(control$gnls))
       ctr$gnls[names(control$gnls)] <- control$gnls
    if(!is.null(control$pul))
      ctr$pul[names(control$pul)] <- control$pul
    }
  p.old <- p <- puloc
  t.flag <- 1   
  baseEst <- start$Inif
  idx <- length(puloc)
  listEst <- listStat <- vector("list", 1)
  nobs <- length(tmp0[, 2])
  names(p.old) <- paste("x", 1:length(p.old), sep = "")
  if(ctr$pul$trace)
  {  cat("\nBegin with original selection of features ...\n")
     print(p.old)
  }
  GO1 <- 1
  Initial <- start$fixed
  select.tbl.name <- c("NP","BIC","RIC","AIC","GCV","DF","df(base)","nlaht","N","RSS")
  select.tbl <- matrix(vector(mode = "numeric", length = length(select.tbl.name)), nrow=1)
  TOLr <- ctr$pul$TOLr	# for relative precison of GCVs
  NLMEdf <- NULL
 # main iteration
#  while(GO1) {
    GCVs <- numeric(0)
    RelPrecision <- GO2 <- 1
    Flag1 <- FALSE	# skip RelPrecision at 1st time
    tmp[, res] <- tmp0[, res] - baseEst
    i.go2 <- 0
    while(GO2) {
      if(nlme)
        NLMEfit <- NLMEcallx(tmp, Initial, p, pulseForm, parList, ctr$nlme, corr = correlation, weight = weights)
      else
        NLMEfit <- GNLScallx(tmp, Initial, p, pulseForm, parList, ctr$nlme, corr = correlation, weight = weights)
 ###########deal with problem of breakdown of nlme###########
#      if(any(is.na(NLMEfit))) break
#      else
#      {
############################################################
      
	tmp[, res] <- tmp0[, res] - NLMEfit$fit
      tmp[,ind] <- xscale( tmp[, ind] )
      if ( is.null(weights) && is.null(correlation) )
        s.wt <- NULL else {
          if ( !is.null(weights) ) {
            varSt <- varWeights(NLMEfit$nlmeObj$modelStruct$varStruct)
            if ( is.null(correlation) )
              s.wt <- (1/varSt)^2
            else {
              corSt <- corMatrix(NLMEfit$nlmeObj$modelStruct$corStruct)
              s.wt <- (1/varSt)^2 %*% corSt
              }
            } else {
              s.wt <- corMatrix(NLMEfit$nlmeObj$modelStruct$corStruct)
              }
          }

      if(is.null(baseline)) 
         {
 	   SSRfit <- list(fit=0, ssrObj=list(rkpk.obj=list(df=0, nlaht=NA)), gcvS=GCVs)
	   RelPrecision <- 0
	   }
	else {
###???      form <- paste(res, deparse(baseline$nb))
         form <- paste(deparse(xcall$y), deparse(baseline$nb[[2]]), sep="~")
         
         I <- rep(1, dim(tmp)[1])
         if(length(varName) == 0) 
            {s <- matrix(I, ncol=1)
             rk <- baseline$rk}
         else
            {tt <- xscale(eval(as.name(varName), env=data.orig))
             rk.data <- data.frame(I, tt)
             dimnames(rk.data)[[2]] <- c("I", varName)
             if(length(all.vars(baseline$nb))==0) s <- matrix(I, ncol=1)
             else   
                s <- model.matrix(as.formula(paste("I", deparse(baseline$nb[[2]]), sep="~")), data=rk.data)
             rk <- eval(baseline$rk, env=rk.data)
            }
         SSRfit <- SSRcall(tmp[, res], s=s, form, Updata = tmp, rk= rk, op = ctr$ssr$spar,
                        weight = s.wt, corr = NULL, limnla=ctr$ssr$limnla)
      }
      tmp[,ind] <- tmp0[, ind]
      if(Flag1) {
        RelPrecision <- abs(GCVs - SSRfit$gcvS)/GCVs
        }
      GO2 <- ifelse(RelPrecision >= TOLr, 1, 0)
      if ( is.null(s.wt) ) {
        RSS <- sum((tmp0[, res] - (NLMEfit$fit + SSRfit$fit))^2) }
      else {
        RSS <- (tmp0[, res] - (NLMEfit$fit + SSRfit$fit)) %*% solve(s.wt) %*% (tmp0[, res] - (NLMEfit$fit + SSRfit$fit))
     }
      NLMEdf <- (2 * NLMEfit$info["LogLik"] + NLMEfit$info["AICV"])/2
      IDF <- ctr$pul$IDF
      if(idx == length(puloc)) {
        SIGMA2 <- RSS/(nobs - NLMEdf - SSRfit$ssrObj$rkpk.obj$df)
 ###??? definition of df (in the paper and here for different situations
       df.T <- SSRfit$ssrObj$rkpk.obj$df + IDF*(length(unlist(parList$random))*length(p)+length(parList$fixed)+length(parList$common))
        }
      Sigma2 <- RSS/(nobs - NLMEdf - SSRfit$ssrObj$rkpk.obj$df)
      df.t <- SSRfit$ssrObj$rkpk.obj$df + IDF*(length(unlist(parList$random))*length(p)+length(parList$fixed)+length(parList$common))
      bic <- RSS + SIGMA2*log(nobs)*( df.t )
      ric <- RSS + SIGMA2*2*log(df.T)*df.t
      aic <- RSS + SIGMA2*2*df.t
      gcv <- RSS / (1-df.t/nobs)^2
      ModelSelect <- c(length(p), bic, ric, aic, gcv, df.t, SSRfit$ssrObj$rkpk.obj$df, 
                       SSRfit$ssrObj$rkpk.obj$nlaht, nobs, RSS)
      names(ModelSelect) <- select.tbl.name

      GCVs <- SSRfit$gcvS
      BaseLine <- SSRfit$fit
      tmp[, res] <- tmp0[, res] - BaseLine
#      ApInitial <- NLMEfit$NextFixed
      Flag1 <- TRUE
      i.go2 <- i.go2 + 1
#      }
}
###########deal with problem of breakdown of nlme###########
#    if(!any(is.na(NLMEfit))) 
#    {
###########################################################
     Varmat <- NULL
     Varmat <- posterior.ranef.info(NLMEfit, SSRfit, baseline, p, tmp0[, ind], devList, parList, Sigma2, level = 0.05)$Var
     varnames <- c(names(NLMEfit$NextFixed), names(NLMEfit$ranEst))
#print(dim(Varmat))
#print(varnames)
     dimnames(Varmat) <- list(varnames, varnames)
     listEst <- list(coef = list(fixed=NLMEfit$NextFixed, ranEst = NLMEfit$ranEst), Var=Varmat,
sigma=sqrt(Sigma2),  baseFitted = SSRfit$fit, nlmeFitted = NLMEfit$fit, nlmeObj = NLMEfit$nlmeObj, gnlsObj=NLMEfit$gnlsObj, ssrObj = SSRfit$ssrObj, callxObj=NLMEfit)
#    postr.info <- posterior.ranef.info(NLMEfit, p, tmp0[, ind], devList, parList, level = 0.05)
#    postr.info <- postr.info[1:length(p),  ]
#    listStat[[idx]] <- tmp1 <- cbind(p, postr.info)
#    ModelSelect["DROP"] <- tmp1[tmp1[, "t-value"] == min(tmp1[,"t-value"]), "p"]
    select.tbl <- rbind(select.tbl, ModelSelect)
    Q.print <- (!as.logical(GO2) && Flag1)
    if(Q.print & ctr$pul$trace) {
        cat(paste("\niterations : ", i.go2, "times", "\n"))
        cat(paste("relative precision", signif(RelPrecision, 6), "(", "<", TOLr, ")", "\n"))
    }

  select.tbl <- as.data.frame(select.tbl[-1,  ])
  dimnames(select.tbl)[[1]] <- 1:(dim(select.tbl)[1])
  if(t.flag | (ncol(select.tbl) ==1)) {
        dimnames(select.tbl)[[1]] <- select.tbl.name
        select.tbl <- as.data.frame(t(select.tbl))
        dimnames(select.tbl)[[1]] <- ""  
  }
  if(ctr$pul$trace)
  {  cat("\nSummary of statistics:\n")
     if ( t.flag) {
        print(select.tbl)
      }
      else 
         print(as.data.frame(select.tbl[,-1], row.names=as.character(select.tbl[,"NP"])))
  }
#}
  obj <- list(tbl = select.tbl, coef = listEst$coef, Var=listEst$Var, sigma=listEst$sigma, baseFitted = listEst$baseFitted, nlmeFitted = listEst$nlmeFitted, nlmeObj = listEst$nlmeObj, gnlsObj=listEst$gnlsObj, ssrObj = listEst$ssrObj, callxObj=listEst$callxObj, nlme=nlme)
  obj$call <- xcall
  class(obj) <- "pulest"
  invisible(obj)
}
#
"print.pulest" <- function(x)
{
  cat("Pulses Estimation with Semiparametric Model\n")
  cat("Call:\n")
  dput(x$call)
  if (dim(x$tbl)[1] !=1)   
      xx <- x$tbl[,c("BIC","RIC","AIC","GCV","DF")]
  else xx <- x$tbl[1,c("BIC","RIC","AIC","GCV","DF")]
  cat("\n\nFitting Table :\n")
  print(xx)
  cat("Pulse location(s) :")
  cat(eval(x$call$puloc, env=sys.parent()),"\n")
  invisible()
}

"summary.pulest"  <- function(x)
{
  
  cat("Estimation for Hormone Pulses\n")
  cat("Call:\n")
  dput(x$call)
  cat("\n\nFitting Table :\n")
  print(x$tbl)
  puloc <- eval(x$call$puloc, env=sys.parent())
  k <- length(puloc)
  cat("Pulse locations :")
  cat(puloc,"\n")
  ssrTmp <- x$ssrObj

  nlmeDF <- (2 * x$callxObj$info["LogLik"] + x$callxObj$info["AICV"])/2
  dims <- data.frame(N=x$tbl[1,"N"], p=x$ssrObj$rkpk.obj$df+nlmeDF)
 
  if(!x$nlme)
  {
    tTable <- data.frame(unlist(x$coef), sqrt(diag(x$Var)), unlist(x$coef)/sqrt(diag(x$Var)), unlist(x$coef))
    dimnames(tTable) <- list(dimnames(x$Var)[[1]], c("Value", "Std.Error", "t-value", "p-value"))
    tTable[, "p-value"] <- 2 * pt( - abs(tTable[, "t-value"]), dims$N - dims$p)
    tTable <- as.matrix(tTable)
    cat("\nEstimation: \n\nParametric component\n")
    cat("\n Fixed effects:\n")
    print(tTable)
  }
  else
  { 
    mfixed <- length(x$coef$fixed)
    tTable <- data.frame(x$coef$fixed, sqrt(diag(x$Var[1:mfixed, 1:mfixed])), unlist(x$coef$fixed)/sqrt(diag(x$Var[1:mfixed, 1:mfixed])), unlist(x$coef$fixed))
    dimnames(tTable) <- list(names(x$coef$fixed), c("Value", "Std.Error", "t-value", "p-value"))
    tTable[, "p-value"] <- 2 * pt( - abs(tTable[, "t-value"]), dims$N - dims$p)
    tTable <- as.matrix(tTable)
    cat("\nEstimation at the selected model: \n\nParametric component\n")
    cat("\n Fixed effects:\n")
    print(tTable)
    ranSdDev <- x$callxObj$ranSdDev
    ranSdDev <- rep(ranSdDev, rep(k, length(ranSdDev)))
    names(ranSdDev) <- names(x$coef$ranEst)
    cat("\n Random effects:\n")
    print(ranSdDev)
  }

  cat("\nNon-parametric\n")
  cat("estimate of smoothing parameter :", format(10^ssrTmp$rkpk.obj$nlaht/dims$N), "\n")
  cat("Degrees of Freedom of the baseline (df(base)): ", format(ssrTmp$rkpk.obj$df), "\n")
  if(!is.null(ssrTmp$cor.est))
    print(ssrTmp$cor.est)
  if(!is.null(ssrTmp$var.est))
    print(ssrTmp$var.est)
  cat("\nResidual standard deviation: ")
  cat(paste(round(x$sigma, 3)), "on ", paste(round(dims$N - dims$p, 3)), " degrees of freedom\n")
 
  invisible()
} # 


########################################################################################
#"ginverse" <- function(x, tol = sqrt(.Machine$double.eps))
#{
## return Moore-Penrose inverse of a matrix x, not available in Splus 3.4
#	if(length(dim(x)) > 2) stop("x must be a matrix or vector")
#	svdX <- svd(x)
#	if(is.complex(x))
#		svdX$u <- Conj(svdX$u)
#	NotZero <- svdX$d > tol * svdX$d[1]
#	ans <- if(all(NotZero)) svdX$v %*% ((1/svdX$d) * t(svdX$u)) else if(!
#		any(NotZero)) {
#		if(is.matrix(x))
#			array(0, dim(x)[2:1])
#		else matrix(0, 1, length(x))
#	}
#	else svdX$v[, NotZero] %*% ((1/svdX$d[NotZero]) * t(svdX$u[, NotZero]))
#	attr(ans, "rank") <- sum(NotZero)
#	ans
#}
#######################################################################################

#########	
"xscale" <- 
function(x, s = x)
{
# scale a vector ...
  if(max(x) <= max(s)) {
    #x <- as.vector(x)
    (x - min(s))/diff(range(s))
    }
  else stop(paste(deparse(substitute(x)), "should be less than", deparse(substitute(s))))
}

#"%!%" <- function(a, b)
#    {
#     tmp <- function(c)
#     { a <- c[1]
#       b <- c[2]
#      if(is.finite(a))
#     {if(is.finite(b)) return(a*b)
#      else if(a==0) return(0)
#      else return(NaN)
#     }
#     else if(is.finite(b))
#       {if(b==0) return(0) 
#        else return(NaN)}
#     else return(NaN)}
#    return(apply(cbind(a,b), 1, tmp))
#}
########	
	
	
## end of file
